<?php
/*
+ ----------------------------------------------------------------------------------------------------+
|        e107 website system 
|        Plugin defaults - e107_plugins/zencart_bridge/includes/zencart_bridge_defaults.php
|        $Revision: 474 $
|        $Date: 2007-08-28 19:08:42 +0300 (Tue, 28 Aug 2007) $
|        $Author: secretr $
|	     GNU GPL License (http://gnu.org)
+----------------------------------------------------------------------------------------------------+
*/
if (!defined('e107_INIT')) { exit; }

$ZENCART_BRIDGE_XFIELDS = array();

$ZENCART_BRIDGE_XFIELDS['zen_company'] = array('zen_company','LAN_ZENBRIDGE_INSTALL_2',1,'^,^^,^^,^0','','',0,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_gender'] = array('zen_gender','LAN_ZENBRIDGE_INSTALL_3',2,'^,^^,^^,^0',LAN_ZENBRIDGE_INSTALL_14a.','.LAN_ZENBRIDGE_INSTALL_14b,'',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_firstname'] = array('zen_firstname','LAN_ZENBRIDGE_INSTALL_4',1,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_lastname'] = array('zen_lastname','LAN_ZENBRIDGE_INSTALL_5',1,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_address1'] = array('zen_address1','LAN_ZENBRIDGE_INSTALL_6',1,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_address2'] = array('zen_address2','LAN_ZENBRIDGE_INSTALL_7',1,'^,^^,^^,^0','','',0,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_city'] = array('zen_city','LAN_ZENBRIDGE_INSTALL_8',1,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_state'] = array('zen_state','LAN_ZENBRIDGE_INSTALL_9',1,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_zipcode'] = array('zen_zipcode','LAN_ZENBRIDGE_INSTALL_10',6,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_phone'] = array('zen_phone','LAN_ZENBRIDGE_INSTALL_11',1,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_fax'] = array('zen_fax','LAN_ZENBRIDGE_INSTALL_12',1,'^,^^,^^,^0','','',0,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_newsletter'] = array('zen_newsletter','LAN_ZENBRIDGE_INSTALL_13',2,'^,^^,^^,^0',LAN_ZENBRIDGE_INSTALL_15a.','.LAN_ZENBRIDGE_INSTALL_15b.','.LAN_ZENBRIDGE_INSTALL_15c,'',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');

//new! user_zen_id, user_zen_email, user_zen_sess
$ZENCART_BRIDGE_XFIELDS['zen_id'] = array('zen_id','LAN_ZENBRIDGE_INSTALL_17',1,'readonly=\'readonly\'^,^^,^^,^0','','',0,e_UC_ADMIN,e_UC_ADMIN,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_email'] = array('zen_email','LAN_ZENBRIDGE_INSTALL_18',1,'readonly=\'readonly\'^,^^,^^,^0','','',0,e_UC_ADMIN,e_UC_ADMIN,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['zen_sess'] = array('zen_sess','LAN_ZENBRIDGE_INSTALL_19',1,'readonly=\'readonly\'^,^^,^^,^0','','',0,e_UC_ADMIN,e_UC_ADMIN,e_UC_MEMBER,'');

//now create the birthday and country fields, compatible to e107 predefines
$ZENCART_BRIDGE_XFIELDS['birthday'] = array('birthday','UE_LAN_BIRTHDAY',7,'^,^^,^^,^0','','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');
$ZENCART_BRIDGE_XFIELDS['country'] = array('country','UE_LAN_COUNTRY',4,'^,^^,^^,^0','user_extended_country,country_iso,country_name,country_name','',1,e_UC_ADMIN,e_UC_MEMBER,e_UC_MEMBER,'');

function zencart_bridge_xfinstall()
{
    global $sql, $tp, $ZENCART_BRIDGE_XFIELDS;   
    
    if($sql->db_Select('user_extended_struct',"user_extended_struct_id", "user_extended_struct_name='".$tp -> toDB(LAN_ZENBRIDGE_INSTALL_1)."'")) {
        $tmp = $sql -> db_Fetch();
        $parent = $tmp['user_extended_struct_id'];
        unset($tmp);
    } else {
        $parent = $sql->db_Insert('user_extended_struct',array(  'user_extended_struct_name' => $tp -> toDB(LAN_ZENBRIDGE_INSTALL_1),
                                                                 'user_extended_struct_type' => 0,
                                                                 'user_extended_struct_read' => e_UC_ADMIN,
                                                                 'user_extended_struct_write' => e_UC_MEMBER,
                                                                 'user_extended_struct_applicable' => e_UC_MEMBER)  );
    }
    

    foreach ($ZENCART_BRIDGE_XFIELDS as $key => $value) {
    	zencart_bridge_xfadd($value, $parent);
    }
    
}

function zencart_bridge_xfadd($args = array(), $parent=0)
{
    global $sql;
    static $ue = false;   
    
    if(!$args || !is_array($args))
        return false;
    
    if($parent) $args[] = intval($parent);
      
    if(!$ue) {
        require_once(e_HANDLER.'user_extended_class.php');
        $ue = new e107_user_extended();
    }
    
    if(call_user_func_array(array(&$ue, 'user_extended_add'), $args)) {
        if($args[2] == 4 && is_readable(e_ADMIN."sql/extended_".$args[0].".php") && !$sql->db_Count('user_extended_'.$args[0],'(*)')) {
            //db table
            return zencart_bridge_process_sql($args[0]);
        }
        
        return true;
        
    } else 
        return false;
    
}

//exact copy of user_extended process_sql function
function zencart_bridge_process_sql($f)
{
    global $sql;
	$filename = e_ADMIN."sql/extended_".$f.".php";
	$fd = fopen ($filename, "r");
	$sql_data = fread($fd, filesize($filename));
	fclose ($fd);

	$search[0] = "CREATE TABLE ";	$replace[0] = "CREATE TABLE ".MPREFIX;
	$search[1] = "INSERT INTO ";	$replace[1] = "INSERT INTO ".MPREFIX;

    preg_match_all("/create(.*?)myisam;/si", $sql_data, $creation);
    foreach($creation[0] as $tab){
		$query = str_replace($search,$replace,$tab);
      	if(!mysql_query($query)){
        	$error = TRUE;
		}
	}

    preg_match_all("/insert(.*?);/si", $sql_data, $inserts);
	foreach($inserts[0] as $ins){
		$qry = str_replace($search,$replace,$ins);
		if(!mysql_query($qry)){
		  	$error = TRUE;
		}
    }

	return ($error) ? FALSE : TRUE;

}

?>