<?php
/**
 * File contains just the shopping cart class
 *
 * @package classes
 * @copyright Copyright 2003-2006 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: shopping_cart.php 4884 2006-11-05 00:32:55Z ajeh $
 */
/**
 * Class for managing the Shopping Cart
 *
 * @package classes
 * @copyright Copyright 2003-2006 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 */
if (!defined('e107_INIT')) { exit; }
}
class shoppingCart {
  /**
   * shopping cart contents
   * @var array
   */
  var $zcon = null;
  /**
   * shopping cart contents
   * @var array
   */
  var $contents;
  /**
   * shopping cart total price
   * @var decimal
   */
  var $total;
  /**
   * shopping cart total weight
   * @var decimal
   */
  var $weight;
  /**
   * cart identifier
   * @var integer
   */
  var $cartID;
  /**
   * overall content type of shopping cart
   * @var string
   */
  var $content_type;
  /**
   * number of free shipping items in cart
   * @var decimal
   */
  var $free_shipping_item;
  /**
   * total price of free shipping items in cart
   * @var decimal
   */
  var $free_shipping_weight;
  /**
   * total weight of free shipping items in cart
   * @var decimal
   */
  var $free_shipping_price;
  /**
   * constructor method
   *
   * Simply resets the users cart.
   * @return void
   */
  function shoppingCart() {
    $this->zcon = &zencart_bridge_connection();        
    $this->reset();
  }
  /**
   * Method to restore cart contents
   *
   * For customers who login, cart contents are also stored in the database.
   * {TABLE_CUSTOMER_BASKET et al}. This allows the system to remember the
   * contents of their cart over multiple sessions.
   * This method simply retrieve the content of the databse store cart
   * for a given customer. Note also that if the customer already has
   * some items in their cart before thet login, these are merged with
   * the stored contents.
   *
   * @return void
   * @global object access to the db object
   */
  function restore_contents() {
    global $pref;
    if (!$_SESSION['customer_id']) return false;

    if(!$this->zcon) return false;
        
    // insert current cart contents in database
    if (is_array($this->contents)) {
      reset($this->contents);
      while (list($products_id, ) = each($this->contents)) {
        //          $products_id = urldecode($products_id);
        $qty = $this->contents[$products_id]['qty'];
        $product_query = "select products_id
                            from ".$pref['zencart_bridge_prefix']."customers_basket
                            where customers_id = '" . (int)$_SESSION['customer_id'] . "'
                            and products_id = '" . addslashes($products_id) . "'";

        $product = false;
        $cnt = 0;
        if($res = @mysql_query($product_query, $this->zcon)) {
            if($cnt = mysql_num_rows($res)) {
                $product = mysql_fetch_assoc($res);
            }
        }

        if ($cnt<=0) {
          $sql = "insert into ".$pref['zencart_bridge_prefix']."customers_basket
                                (customers_id, products_id, customers_basket_quantity,
                                 customers_basket_date_added)
                                 values ('" . intval($_SESSION['customer_id']) . "', '" . addslashes($products_id) . "', '" .
          $qty . "', '" . date('Ymd') . "')";

          @mysql_query($product_query, $this->zcon);

          if (isset($this->contents[$products_id]['attributes'])) {
            reset($this->contents[$products_id]['attributes']);
            while (list($option, $value) = each($this->contents[$products_id]['attributes'])) {

              //clr 031714 udate query to include attribute value. This is needed for text attributes.
              $attr_value = $this->contents[$products_id]['attributes_values'][$option];
              //                zen_db_query("insert into " . TABLE_CUSTOMERS_BASKET_ATTRIBUTES . " (customers_id, products_id, products_options_id, products_options_value_id, products_options_value_text) values ('" . (int)$customer_id . "', '" . zen_db_input($products_id) . "', '" . (int)$option . "', '" . (int)$value . "', '" . zen_db_input($attr_value) . "')");
              $pieces = explode(':', $products_id);
              $products_options_sort_order= $this -> zen_get_attributes_options_sort_order($pieces[0], $option, $value);
              if ($attr_value) {
                $attr_value = addslashes($attr_value);
              }
              $sql = "insert into ".$pref['zencart_bridge_prefix']."customers_basket_attributes
                                    (customers_id, products_id, products_options_id,
                                     products_options_value_id, products_options_value_text, products_options_sort_order)
                                     values ('" . (int)$_SESSION['customer_id'] . "', '" . addslashes($products_id) . "', '" .
              $option . "', '" . $value . "', '" . $attr_value . "', '" . $products_options_sort_order . "')";

              @mysql_query($sql, $this->zcon);
            }
          }
        } else {
          $sql = "update ".$pref['zencart_bridge_prefix']."customers_basket
                    set customers_basket_quantity = '" . $qty . "'
                    where customers_id = '" . (int)$_SESSION['customer_id'] . "'
                    and products_id = '" . addslashes($products_id) . "'";

          @mysql_query($sql, $this->zcon);

        }
      }
    }

    // reset per-session cart contents, but not the database contents
    $this->reset(false);

    $products_query = "select products_id, customers_basket_quantity
                         from ".$pref['zencart_bridge_prefix']."customers_basket
                         where customers_id = '" . intval($_SESSION['customer_id']) . "'";

    $products_arr = array();

    if($res = @mysql_query($products_query, $this->zcon)) {
        if(mysql_num_rows($res)) {
            while($product = mysql_fetch_assoc($res)) {
                $products_arr[] = $product;
            }
        }
    }
    
    

    foreach ($products_arr as $products) {
      $this->contents[$products['products_id']] = array('qty' => $products['customers_basket_quantity']);
      // attributes
      // set contents in sort order

      //CLR 020606 update query to pull attribute value_text. This is needed for text attributes.
      //        $attributes_query = zen_db_query("select products_options_id, products_options_value_id, products_options_value_text from " . TABLE_CUSTOMERS_BASKET_ATTRIBUTES . " where customers_id = '" . (int)$customer_id . "' and products_id = '" . zen_db_input($products['products_id']) . "'");

      $order_by = ' order by LPAD(products_options_sort_order,11,"0")';

        $attributes_arr = array();
        $qry = "select products_options_id, products_options_value_id, products_options_value_text
                             from " . TABLE_CUSTOMERS_BASKET_ATTRIBUTES . "
                             where customers_id = '" . (int)$_SESSION['customer_id'] . "'
                             and products_id = '" . zen_db_input($products->fields['products_id']) . "' " . $order_by;
                             
        if($res = @mysql_query($qry, $this->zcon)) {
            if(mysql_num_rows($res)) {
                while($row = mysql_fetch_assoc($res)) {
                    $attributes_arr[] = $row;
                }
            }
        }
      
      foreach ($attributes_arr as $attributes) {
        $this->contents[$products['products_id']]['attributes'][$attributes['products_options_id']] = $attributes['products_options_value_id'];
        //CLR 020606 if text attribute, then set additional information
        if ($attributes['products_options_value_id'] == PRODUCTS_OPTIONS_VALUES_TEXT_ID) {
          $this->contents[$products['products_id']]['attributes_values'][$attributes['products_options_id']] = $attributes['products_options_value_text'];
        }

      }

    }

    $this->cleanup();
  }
  /**
   * Method to reset cart contents
   *
   * resets the contents of the session cart(e,g, empties it)
   * Depending on the setting of the $reset_database parameter will
   * also empty the contents of the database stored cart. (Only relevant
   * if the customer is logged in)
   *
   * @param boolean whether to reset customers db basket
   * @return void
   * @global object access to the db object
   */
  function reset($reset_database = false) {
    global $pref;
    if(!$this->zcon) return false;

    $this->contents = array();
    $this->total = 0;
    $this->weight = 0;
    $this->content_type = false;

    // shipping adjustment
    $this->free_shipping_item = 0;
    $this->free_shipping_price = 0;
    $this->free_shipping_weight = 0;

    if (isset($_SESSION['customer_id']) && ($reset_database == true)) {
      $qry = "delete from ".$pref['zencart_bridge_prefix']."customers_basket
                where customers_id = '" . intval($_SESSION['customer_id']) . "'";

      @mysql_query($qry, $this->zcon);

      $qry = "delete from ".$pref['zencart_bridge_prefix']."customers_basket_attributes
                where customers_id = '" . intval($_SESSION['customer_id']) . "'";

      @mysql_query($qry, $this->zcon);
    }

    unset($this->cartID);
    $_SESSION['cartID'] = '';
  }


  /**
   * Method to clean up carts contents
   *
   * For various reasons, the quantity of an item in the cart can
   * fall to zero. This method removes from the cart
   * all items that have reached this state. The database-stored cart
   * is also updated where necessary
   *
   * @return void
   * @global object access to the db object
   */
  function cleanup() {
    global $pref;
    if(!$this->zcon) return false;
    
    reset($this->contents);
    while (list($key,) = each($this->contents)) {
      if (!isset($this->contents[$key]['qty']) || $this->contents[$key]['qty'] <= 0) {
        unset($this->contents[$key]);
        // remove from database
        if (isset($_SESSION['customer_id'])) {
          $sql = "delete from ".$pref['zencart_bridge_prefix']."customers_basket
                    where customers_id = '" . (int)$_SESSION['customer_id'] . "'
                    and products_id = '" . $key . "'";

          @mysql_query($sql, $this->zcon);

          $sql = "delete from ".$pref['zencart_bridge_prefix']."customers_basket_attributes
                    where customers_id = '" . (int)$_SESSION['customer_id'] . "'
                    and products_id = '" . $key . "'";

          @mysql_query($sql, $this->zcon);
        }
      }
    }

  }
  /**
   * Method to count total number of items in cart
   *
   * Note this is not just the number of distinct items in the cart,
   * but the number of items adjusted for the quantity of each item
   * in the cart, So we have had 2 items in the cart, one with a quantity
   * of 3 and the other with a quantity of 4 our total number of items
   * would be 7
   *
   * @return total number of items in cart
   */
  function count_contents() {

    $total_items = 0;
    if (is_array($this->contents)) {
      reset($this->contents);
      while (list($products_id, ) = each($this->contents)) {
        $total_items += $this->get_quantity($products_id);
      }
    }
    return $total_items;
  }
  /**
   * Method to get the quantity of an item in the cart
   *
   * @param mixed product ID of item to check
   * @return decimal the quantity of the item
   */
  function get_quantity($products_id) {
    if (isset($this->contents[$products_id])) {
      return $this->contents[$products_id]['qty'];
    } else {
      return 0;
    }
  }
  /**
   * Method to check whether a product exists in the cart
   *
   * @param mixed product ID of item to check
   * @return boolean
   */
  function in_cart($products_id) {
    if (isset($this->contents[$products_id])) {
      return true;
    } else {
      return false;
    }
  }

  /**
   * Method return a comma separated list of all products in the cart
   *
   * @return string
   * @todo ICW - is this actually used anywhere?
   */
  function get_product_id_list() {
    $product_id_list = '';
    if (is_array($this->contents)) {
      reset($this->contents);
      while (list($products_id, ) = each($this->contents)) {
        $product_id_list .= ', ' . addslashes($products_id);
      }
    }
    return substr($product_id_list, 2);
  }

  /**
   * Method to calculate total price of items in cart
   *
   * @return decimal Total Price
   */
  function show_total() {

    //$this->calculate();

    return $this->total;
  }

  
/*
 *  return attributes products_options_sort_order
 *  TABLES: PRODUCTS_OPTIONS, PRODUCTS_ATTRIBUTES
 */
  function zen_get_attributes_options_sort_order($products_id, $options_id, $options_values_id) {
    global $pref;
    if(!$this->zcon) return false;
      
      $qry = "select products_options_sort_order
                             from ".$pref['zencart_bridge_prefix']."products_options
                             where products_options_id = '" . (int)$options_id . "' limit 1";
                             
      $res = @mysql_query($qry, $this->zcon);
      $check = @mysql_fetch_assoc($res);

      $qry = "select products_id, options_id, options_values_id, products_options_sort_order
                             from ".$pref['zencart_bridge_prefix']."products_attributes
                             where products_id='" . (int)$products_id . "'
                             and options_id='" . (int)$options_id . "'
                             and options_values_id = '" . (int)$options_values_id . "' limit 1";
                             
      $res = @mysql_query($qry, $this->zcon);
      $check_options_id = @mysql_fetch_assoc($res);                     



      return $check['products_options_sort_order'] . '.' . str_pad($check_options_id['products_options_sort_order'],5,'0',STR_PAD_LEFT);
  }
}
?>